=== debian/changelog ===
soapysdr (0.8.1-7) unstable; urgency=medium

  * update soapysdr0.8-module-all dependencies (Closes: #1118946)
  * Bump Standards-Version to 4.7.2, no changes required

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 03 Nov 2025 21:27:01 -0500

soapysdr (0.8.1-6) unstable; urgency=medium

  * Team upload.
  * Update to build with CMake 4 (Closes: #1113523)

 -- tony mancill <tmancill@debian.org>  Fri, 03 Oct 2025 10:47:53 -0700

soapysdr (0.8.1-5) unstable; urgency=medium

  * Team upload
  * Drop build-dep on python3-distutils and add patch (Closes: #1065958)

 -- tony mancill <tmancill@debian.org>  Sat, 06 Jul 2024 21:08:00 -0700

soapysdr (0.8.1-4) unstable; urgency=medium

  * Remove Breaks: libsoapysdr0.7 as it breaks co-installability with
    libsoapysdr0.7
  * Adapt d/watch to GitHub changes
  * Stop specifying --as-needed linker flag, it is the default now
  * Bump Standards-Version to 4.6.2, no changes required

 -- Andreas Bombe <aeb@debian.org>  Fri, 08 Sep 2023 01:27:36 +0530

soapysdr (0.8.1-3) unstable; urgency=medium

  * Team upload
  * libsoapysdr0.8: Add Breaks: libsoapysdr0.7 for smoother upgrades from
    bullseye.  (Closes: #1036737)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 24 May 2023 09:35:42 +0200

soapysdr (0.8.1-2) unstable; urgency=medium

  * Upload to unstable

 -- Andreas Bombe <aeb@debian.org>  Tue, 07 Sep 2021 00:29:41 +0200

soapysdr (0.8.1-1) experimental; urgency=medium

  * New upstream version 0.8.1
  * Change library ABI version in package names and dependencies from 0.7
    to 0.8
  * Add Rules-Requires-Root field to d/control
  * Update copyright lines in d/copyright
  * Refresh version-string patch
  * Bump Standards-Version to 4.6.0, no changes required

 -- Andreas Bombe <aeb@debian.org>  Wed, 25 Aug 2021 22:05:35 +0200
